accounts/urls.py
from django.urls import path

from .views import login, sign_out, signup

app_name = "accounts"

urlpatterns = [
    path("login/", login, name="login"),
    path("logout/", sign_out, name="logout"),
    path("register/", signup, name="signup"),
]

projects/urls.py
from django.urls import path
from .views import list_projects
from . import views

app_name = "projects"

urlpatterns = [
    path("", list_projects, name="list_projects"),
    path("<int:id>/", views.show_project, name="show_project"),
]

tasks/urls.py
from django.urls import path
from . import views
from .views import MyTasksView

app_name = "tasks"

urlpatterns = [
    path("create/", views.create_task, name="create_task"),
    path("mine/", MyTasksView.as_view(), name="show_my_tasks"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import include, path
from .views import redirect_view
from accounts.views import login, sign_out
from projects.views import list_projects, show_project

urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", list_projects, name="list_projects"),
    path("projects/<int:id>/", show_project, name="show_project"),
    path("accounts/login/", login, name="login"),
    path("", redirect_view, name="home"),
    path("accounts/logout/", sign_out, name="logout"),
    path("tasks/", include("tasks.urls")),
    path("projects/", include("projects.urls")),
]

projects/models.py
from django.db import models

from django.contrib.auth.models import User


class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    owner = models.ForeignKey(
        User, on_delete=models.CASCADE, related_name="projects", null=True
    )

    def __str__(self):
        return self.name


# Create your models here.

tasks/models.py
from django.db import models
from projects.models import Project
from django.contrib.auth.models import User


class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        Project, on_delete=models.CASCADE, related_name="tasks"
    )
    assignee = models.ForeignKey(
        User, null=True, on_delete=models.CASCADE, related_name="tasks"
    )


# Create your models here.

accounts/forms.py
from django import forms


class LoginForm(forms.Form):
    username = forms.CharField(max_length=150)
    password = forms.CharField(max_length=150, widget=forms.PasswordInput)


class SingUpForm(forms.Form):
    username = forms.CharField(max_length=150)
    password = forms.CharField(max_length=150, widget=forms.PasswordInput)
    password_confirmation = forms.CharField(
        max_length=150, widget=forms.PasswordInput
    )

tasks/forms.py
from django import forms
from .models import Task


class TaskForm(forms.ModelForm):
    class Meta:
        model = Task
        exclude = ["is_completed"]

accounts/views.py
from django.shortcuts import render
from accounts.forms import SingUpForm, LoginForm
from django.shortcuts import redirect
from django.contrib.auth import authenticate, logout
from django.contrib import messages
from django.contrib.auth import login as auth_login
from django.contrib.auth.models import User


def signup(request):
    error = ""
    if request.method == "POST":
        form = SingUpForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data["username"]
            password = form.cleaned_data["password"]
            password_confirmation = form.cleaned_data["password_confirmation"]
            if password == password_confirmation:
                user = User.objects.create_user(
                    username=username,
                    password=password,
                )
                auth_login(request, user)
                messages.success(
                    request,
                    "Registration successful.",
                )
                return redirect("/projects/")
            else:
                error = "the password don't match."
                messages.error(
                    request,
                    "the password don't match.",
                )
        messages.error(
            request,
            "Unsuccessful registration. Invalid information.",
        )
    form = SingUpForm()
    return render(
        request=request,
        template_name="accounts/registration/signup.html",
        context={
            "form": form,
            "error": error,
        },
    )


def login(request):
    if request.method == "GET":
        form = LoginForm()
        return render(
            request,
            "accounts/login.html",
            {"form": form},
        )
    elif request.method == "POST":
        form = LoginForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data["username"]
            password = form.cleaned_data["password"]
            user = authenticate(
                request,
                username=username,
                password=password,
            )
            if user:
                auth_login(
                    request,
                    user,
                )
                messages.success(
                    request,
                    f"Hi {username}, welcome back!",
                )
                return redirect("/projects")
        messages.error(
            request,
            "Invalid username or password",
        )
        return render(
            request,
            "accounts/login.html",
            {"form": form},
        )


def sign_out(request):
    logout(request)
    messages.success(
        request,
        "You have been logged out.",
    )
    return redirect("/accounts/login/")

projects/views.py
from django.views.generic import ListView
from .models import Project
from django.contrib.auth.decorators import login_required
from django.shortcuts import get_object_or_404, render


class ProjectListView(ListView):
    model = Project
    template_name = "projects/project_list.html"
    context_object_name = "projects"

    def get_queryset(self):
        # Get the current user
        user = self.request.user

        # Filter the projects by user owner
        queryset = super().get_queryset().filter(owner=user)

        return queryset


def list_projects(request):
    return login_required(ProjectListView.as_view())(request)


@login_required
def project_detail(request, id):
    project = get_object_or_404(Project, id=id)
    return render(
        request, "projects/project_detail.html", {"project": project}
    )


@login_required
def show_project(request, id):
    project = get_object_or_404(Project, id=id)
    context = {"project": project}
    return render(request, "project_detail.html", context)

tasks/views.py
from django.contrib.auth.decorators import login_required
from django.shortcuts import redirect, render
from .forms import TaskForm
from django.views.generic import ListView
from .models import Task
from django.contrib.auth.mixins import LoginRequiredMixin


@login_required
def create_task(request):
    if request.method == "POST":
        form = TaskForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect("project_list")
    else:
        form = TaskForm()

    return render(request, "tasks/create_task.html", {"form": form})


class MyTasksView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/my_tasks.html"
    context_object_name = "tasks"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


# Create your views here.

tracker/views.py
from django.shortcuts import redirect


def redirect_view(request):
    response = redirect("/projects/")
    return response

accounts/templates/accounts/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Document</title>
    </head>
    <body>
        {% block content %}{% endblock %}
    </body>
</html>

accounts/templates/accounts/login copy.html
{% extends 'accounts/base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Login</h1>
            <form method="POST" novalidate>
                {% csrf_token %}
                {{ form.as_p }}
                <button type="submit" value="Login">Login</button>
            </form>
        </div>
    </main>
{% endblock content %}

accounts/templates/accounts/login.html
{% extends 'accounts/base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Login</h1>
            <form method="POST" novalidate>
                {% csrf_token %}
                {{ form.as_p }}
                <button type="submit" value="Login">Login</button>
            </form>
        </div>
    </main>
{% endblock content %}

projects/templates/project_detail.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>{{ project.name }}</h1>
            <p>{{ project.description }}</p>
            <p>
                <a href="{% url 'tasks:create_task' %}">Create a new task</a>
            </p>
            <h2>Tasks</h2>
            {% if project.tasks.exists %}
                <table>
                    <tr>
                        <th>Name</th>
                        <th>Assignee</th>
                        <th>Start date</th>
                        <th>Due date</th>
                        <th>Is completed</th>
                    </tr>
                    {% for task in project.tasks.all %}
                        <tr>
                            <td>{{ task.name }}</td>
                            <td>{{ task.assignee.username }}</td>
                            <td>{{ task.start_date }}</td>
                            <td>{{ task.due_date }}</td>
                            <td>{{ task.is_completed|yesno:"yes,no" }}</td>
                        </tr>
                    {% endfor %}
                </table>
            {% else %}
                <p>This project has no tasks</p>
            {% endif %}
        </div>
    </main>
{% endblock %}

projects/templates/projects/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Document</title>
    </head>
    <body>
        {% block content %}{% endblock %}
    </body>
</html>

projects/templates/projects/list_projects.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Projects</h1>
            {% for project in projects %}
                <div>
                    <h2>
                        <a href="{% url 'projects:create_project' %}">Create Project</a>
                    </h2>
                    <p>{{ project.description }}</p>
                    <p>Number of tasks: {{ project.tasks.all|length }}</p>
                </div>
            {% empty %}
                <p>No projects</p>
            {% endfor %}
            <a href="{% url 'projects:create_project

projects/templates/projects/project_list.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Project List</h1>
            <table>
                <tr>
                    <th>Name</th>
                    <th>Description</th>
                    <th>Number of Tasks</th>
                </tr>
                {% for project in projects %}
                    <tr>
                        <td>
                            <a href="{% url 'projects:show_project' project.id %}">{{ project.name }}</a>
                        </td>
                        <td>{{ project.description }}</td>
                        <td>{{ project.tasks.all|length }}</td>
                    </tr>
                {% endfor %}
            </table>
        </div>
    </main>
{% endblock %}

projects/templates/tasks/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Document</title>
    </head>
    <body>
        {% block content %}{% endblock %}
    </body>
</html>

tasks/templates/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Document</title>
    </head>
    <body>
        {% block content %}{% endblock %}
    </body>
</html>

tasks/templates/create_task.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Create a new task</h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <button type="submit">Create</button>
            </form>
        </div>
    </main>
{% endblock %}

tasks/templates/tasks/create_task.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Create a new task</h1>
            <form method="post">
                {% csrf_token %} {{ form.as_p }}
                <button type="submit">Create</button>
            </form>
        </div>
    </main>
{% endblock %}

tasks/templates/tasks/my_tasks.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>My Tasks</h1>
            {% if tasks %}
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Start date</th>
                            <th>Due date</th>
                            <th>Is completed</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for task in tasks %}
                            <tr>
                                <td>{{ task.name }}</td>
                                <td>{{ task.start_date }}</td>
                                <td>{{ task.due_date }}</td>
                                <td>{{ task.is_completed|yesno:"yes,no" }}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {% else %}
                <p>You have no tasks</p>
            {% endif %}
        </div>
    </main>
{% endblock %}